function y = read_grid(f)
if nargin < 1
  f = 0;
end

if f
  [a n]=read_fbin('/home/jim/saltare/original/grid.bin','ieee-be');
  y = a(n(1)+1:n(2))';
else
  fp = fopen([getenv('HOME') '/saltare/out/grid.bin'],'r');
  a = fscanf(fp,'%f'); % Read in the whole grid
  n = a(1);
  y = a(1+(1:n))';
end
if nargout == 0
  disp(n);
  subplot(2,1,1);
  plot(log(y));
  subplot(2,1,2);
  plot(fy);
  disp(a((2+2*n):end));
end


