module discrete
use params
implicit none
      	INTEGER, parameter :: n2=2 
	INTEGER, parameter ::  nj=nymax
	INTEGER, parameter :: njm= nj-1
	INTEGER, parameter :: nu = 20
	INTEGER, parameter :: nv = 20

      REAL :: airmss(nj)
	real :: vol(nj)
	real :: tau(nj)
!
!      both will be structure `vector' in the 2D version
      type tmpvec1
           REAL U(nj)
      end type tmpvec1
      type tmpvec2
           REAL Y(nj)
           REAL fy(nj)
      end type

      type(tmpvec1) fluid       !fluid velocity, for 2D: fluid.x
      type(tmpvec2) grid        !grid height, for 2D: grid.y

      REAL gborne(n2,nj)
      REAL  uav,vav,u0,v0,u50,v50
      REAL ui(nu),vj(nv)
      INTEGER numu(nu),numv(nv),nums(20)
!
!     In the 2D version Vol and Airmass will be made vectors, too.
!

!      COMMON /griddef/ grid, vol
!      COMMON /fluiddef/ airmss,tau ,gborne ,fluid
!      COMMON /grains/ ui,vj
!     &       ,numu,numv,nums
!     &       ,uav,vav,u50,v50,u0,v0

end module
