function coll_angle (f)
if nargin < 1
  f = 30;
end
f = f*pi/180;
q = linspace(0,pi,500);
a = find(q<f);
b = find(f<=q & q< pi-f);
c = find(pi-f<q);
x = zeros(3,length(q));
x(:,a) = [1-2*sin(q(a))*sin(f); ones(1,length(a));1-sin(q(a))*sin(f)];
x(:,b) = [cos(q(b)+f);cos(q(b)-f);cos(q(b))*cos(f)]; 
x(:,c) = [-ones(1,length(c));2*sin(q(c))*sin(f)-1;sin(q(c))*sin(f)-1];

plot(180*q/pi,x);
axis([0 180 -1 1]);

