      SUBROUTINE WRTOUT(iterat,aero,grains,fstwrt,scr)
!***********************************************************************
!     final ouput writing
!***********************************************************************
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'tracom.inc'
      INCLUDE 'splashmod.inc'
      INCLUDE 'splsh.inc'
      INCLUDE 'strecom.inc'
      INCLUDE 'timing.inc'
      INCLUDE 'discrete.inc'
      INCLUDE 'outdirmod.inc'

      INTEGER aero,grains,iterat
      INTEGER jj,idum
      INTEGER ic4a, ic4b, ic4c, ic4d,rla, rlb, rlc, rld,nrca, nrcb, nrcc, nrcd
      INTEGER endline
!---- endline CHARACTER is 13 on DOS, OS/2 and 10 on HP-UNIX
      DATA endline /10/! /13/   ! change accordingly , CHAR(32)=SPACE

      REAL totfi,totfl,totf2,a
      REAL dum,T,fac,ustar3,ustar8,gstrh
!         gstrh - grain borne stress at max height

      LOGICAL newa,newb,newc,newd
      LOGICAL fstwrt,scr,new
      CHARACTER*12 filea, fileb, filec, filed
      CHARACTER*1 cdum
      DIMENSION a(nymax)
!
!---- file handling
      DATA filea,fileb,filec,filed/'numbers.dat','angles.dat'&
         ,'rates.dat','stress.dat'/
!...  unit numbers
      DATA ic4a,ic4b,ic4c,ic4d /941,942,943,944/
!...  record lengths
      DATA rla, rlb, rlc, rld /76,56,58,141/

      dum=0.
      idum=0
      fac=180./pi
!
!---  Open the files:
!
      CALL OPFI2(OUTDIR(1:Laenge)//filea&
            ,ic4a,'FORMATTED',rla,nrca,fstwrt,newa)
      CALL OPFI2(OUTDIR(1:Laenge)//fileb&
           ,ic4b,'FORMATTED',rlb,nrcb,fstwrt,newb)
      CALL OPFI2(OUTDIR(1:Laenge)//filec&
           ,ic4c,'FORMATTED',rlc,nrcc,fstwrt,newc)
      CALL OPFI2(OUTDIR(1:Laenge)//filed&
           ,ic4d,'FORMATTED',rld,nrcd,fstwrt,newd)
      IF (.not.newa) THEN
         read(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum&
                ,dum,dum,cdum
      ELSE
         write(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum&
               ,dum,dum,char(endline)
      ENDIF
      IF (.not.newb) THEN
         read(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
                ,cdum
      ELSE
         write(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
               ,char(endline)
      ENDIF
      IF (.not.newc) THEN
         read(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
                ,cdum
      ELSE
         write(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
               ,char(endline)
      ENDIF
      IF (.not.newd) THEN
         read(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
                ,cdum
      ELSE
         write(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
               ,char(endline)
      ENDIF
      area=bedwid*bedlen

      IF (scr) write(*,'(a)') '[24;79H[1;33mF[0m'
!
!---- contemporary flux data per unit area and unit time
!     factor for write-out DO-loop:

      DO jj=2,nymax-1
         a(jj)=bedwid*(grid.y(jj)-grid.y(jj-1))
      ENDDO
!...    think THIS ONE over
      a(nymax)=1.

      totfi=0.
      totf2=0.
      gstrh=0.
      DO jj=2,nymax-1
        totfi=totfi+dflux(jj)
        totf2=totf2+dtmflx(jj)
!        dflux(jj)=dflux(jj)/(tstep*a(jj))
        gstrh=gstrh+dmom(jj).x
      ENDDO
      gstrh=gstrh/(area*tstep)

      totfl=totfi/(bedwid*tstep)
      totf2=totf2/(area)
!
!...  into 4A
      nrca=nrca+1
      write(ic4a,101,rec=nrca) iterat,iterat*tstep&
           ,aero,Daughters,-Deads,Grains,Impacts,Ejecta&
           ,Impacts/(area*tstep),Ejecta/(area*tstep)&
     &     ,char(endline)
!
!...  into 4B
      nrcb=nrcb+1
      T=(float(Impacts-Deads)+1.e-30)    ! truly rebound grains
      write(ic4b,102,rec=nrcb)&
            iterat,iterat*tstep,av.v_in/T,av.a_in*fac/T,av.v_out/T,av.a_out*fac/T&
            ,Impacts-Deads,char(endline)
!
!...  into 4C (rates.dat)
      nrcc=nrcc+1
      write(ic4c,103,rec=nrcc) iterat, iterat*tstep&
          ,totfl,tmflx/(area),totf2&
          ,char(endline)
!
!...  into 4D
      ustar3=sign(sqrt(abs(tau(2))/fdens),tau(2))
      ustar8=sign(sqrt(abs(tau(nj-5))/fdens),tau(nj-5))
! this would work for sinus:
!      ustar8=vkarman*(fluid.U(nj)-fluid.U(nj-5))/log(grid.y((nj)/grid.y((nj-5))

      nrcd=nrcd+1
      write(ic4d,104,rec=nrcd) iterat, iterat*tstep&
          ,tmflx/(area),totfl,tau(2),ustar3,tau(nj-5),ustar8&
          ,gstrh,fluid.U(16),fluid.U(njm)&
!
!          ,totfl,gstrh,tau(2),ustar2,ustar3,fluid.U(njm)&
!          ,fluid.U(2),tau(2),fluid.U(njm/2),fluid.U(njm)&
          ,char(endline)
!
!---  closing the files
      write(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum,dum,dum&
            ,char(endline)
      write(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
            ,char(endline)
      write(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
            ,char(endline)
      write(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
            ,char(endline)
      CLOSE(ic4a)
      CLOSE(ic4b)
      CLOSE(ic4c)
      CLOSE(ic4d)
!
!---- Formats and such
!     for 4A:
  101 FORMAT(i5,1x,e11.4,6(1X,i5),2(1x,e10.3),a)
!     for 4B:
  102 FORMAT(i5,1x,e11.4,4(1x,f7.2),1x,i5,a)
!     for 4C:
  103 FORMAT(i5,4(1x,e12.5),a)
!     for 4D:
  104 FORMAT(i5,10(1X,e12.5),a)
!.... keep these 'CLOSE' for possible system crashes and 'Ctrl-C's
      RETURN
      END
