      subroutine wrtout(iterat,aero,grains,fstwrt,scr)
!***********************************************************************
!     final ouput writing
!***********************************************************************
      use params
      use pars
      use particle
      use tracom
      use splashmod
      use splsh
      use strecom
      use timing
      use discrete
      use outdirmod
      use sysdep_io
      use opfi2

      integer aero,grains,iterat
      integer jj,idum
      integer ic4a, ic4b, ic4c, ic4d,rla, rlb, rlc, rld,nrca, nrcb, nrcc, nrcd
      integer endline
!---- endline character is 13 on dos, os/2 and 10 on hp-unix
      data endline /10/! /13/   ! change accordingly , char(32)=space

      real(r_kind) totfi,totfl,totf2,a
      real(r_kind) dum,t,fac,ustar3,ustar8,gstrh
!         gstrh - grain borne stress at max height

      logical newa,newb,newc,newd
      logical fstwrt,scr
      !logical new
      character(len=12) filea, fileb, filec, filed
      character(len=1) cdum
      dimension a(nymax)
!
!---- file handling
      filea = 'numbers.dat'
      fileb = 'angles.dat'
      filec = 'rates.dat'
      filed = 'stress.dat'
!...  unit numbers

      call assign_lun(ic4a)
      call assign_lun(ic4b)
      call assign_lun(ic4c)
      call assign_lun(ic4d)
      
!...  record lengths
      rla = 76
      rlb = 56
      rlc = 58
      rld = 141
      dum=0.
      idum=0
      fac=180./pi
!
!---  open the files:
!
      call opfi2_write(trim(outdir)//filea,ic4a&
            ,'formatted',rla,nrca,fstwrt,newa)
      call opfi2_write(trim(outdir)//fileb,ic4b&
           ,'formatted',rlb,nrcb,fstwrt,newb)
      call opfi2_write(trim(outdir)//filec,ic4c&
           ,'formatted',rlc,nrcc,fstwrt,newc)
      call opfi2_write(trim(outdir)//filed,ic4d&
           ,'formatted',rld,nrcd,fstwrt,newd)
      if ( .not. newa) then
         read(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum&
                ,dum,dum,cdum
      else
         write(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum&
               ,dum,dum,char(endline)
      endif
      if ( .not. newb) then
         read(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
                ,cdum
      else
         write(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
               ,char(endline)
      endif
      if ( .not. newc) then
         read(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
                ,cdum
      else
         write(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
               ,char(endline)
      endif
      if ( .not. newd) then
         read(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
                ,cdum
      else
         write(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
               ,char(endline)
      endif
      area=bedwid*bedlen

      if (scr) write(*,'(a)') '[24;79h[1;33mf[0m'
!
!---- contemporary flux data per unit area and unit time
!     factor for write-out do-loop:

      do jj=2,nymax-1
         a(jj)=bedwid*(grid%y(jj)-grid%y(jj-1))
      enddo
!...    think this one over
      a(nymax)=1.

      totfi=0.
      totf2=0.
      gstrh=0.
      do jj=2,nymax-1
        totfi=totfi+dflux(jj)
        totf2=totf2+dtmflx(jj)
!        dflux(jj)=dflux(jj)/(tstep*a(jj))
        gstrh=gstrh+dmom(jj)%x
      enddo
      gstrh=gstrh/(area*tstep)

      totfl=totfi/(bedwid*tstep)
      totf2=totf2/(area)
!
!...  into 4a
      nrca=nrca+1
      write(ic4a,101,rec=nrca) iterat,iterat*tstep&
           ,aero,daughters,-deads,grains,impacts,ejecta&
           ,impacts/(area*tstep),ejecta/(area*tstep)&
     &     ,char(endline)
!
!...  into 4b
      nrcb=nrcb+1
      t=(float(impacts-deads)+1.e-30)    ! truly rebound grains
      write(ic4b,102,rec=nrcb)&
            iterat,iterat*tstep,av%v_in/t,av%a_in*fac/t,av%v_out/t,av%a_out*fac/t&
            ,impacts-deads,char(endline)
!
!...  into 4c (rates%dat)
      nrcc=nrcc+1
      write(ic4c,103,rec=nrcc) iterat, iterat*tstep&
          ,totfl,tmflx/(area),totf2&
          ,char(endline)
!
!...  into 4d
      ustar3=sign(sqrt(abs(tau(2))/fdens),tau(2))
      ustar8=sign(sqrt(abs(tau(nj-5))/fdens),tau(nj-5))
! this would work for sinus:
!      ustar8=vkarman*(fluid%u(nj)-fluid%u(nj-5))/log(grid%y((nj)/grid%y((nj-5))

      nrcd=nrcd+1
      write(ic4d,104,rec=nrcd) iterat, iterat*tstep&
          ,tmflx/(area),totfl,tau(2),ustar3,tau(nj-5),ustar8&
          ,gstrh,fluid%u(16),fluid%u(njm)&
!
!          ,totfl,gstrh,tau(2),ustar2,ustar3,fluid%u(njm)&
!          ,fluid%u(2),tau(2),fluid%u(njm/2),fluid%u(njm)&
          ,char(endline)
!
!---  closing the files
      write(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum,dum,dum&
            ,char(endline)
      write(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
            ,char(endline)
      write(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
            ,char(endline)
      write(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
            ,char(endline)
      close(ic4a);call free_lun(ic4a)
      close(ic4b);call free_lun(ic4b)
      close(ic4c);call free_lun(ic4c)
      close(ic4d);call free_lun(ic4d)
!
!---- formats and such
!     for 4a:
  101 format(i5,1x,e11.4,6(1x,i5),2(1x,e10.3),a)
!     for 4b:
  102 format(i5,1x,e11.4,4(1x,f7.2),1x,i5,a)
!     for 4c:
  103 format(i5,4(1x,e12.5),a)
!     for 4d:
  104 format(i5,10(1x,e12.5),a)
!.... keep these 'close' for possible system crashes and 'ctrl-c's
      return
      end
