module writing
  use sysdep_io
  private 
  public :: open_output_files
  public :: close_output_files
  integer, public ::  saltout_fp
contains
  ! Open the output files
  ! Either overwrite or append depending in the flag new
  subroutine open_output_files(dirn,cont)
    character(len=*), intent(in) :: dirn
    logical, intent(in) :: cont
    if (cont) then
       call err_open(saltout_fp, file=trim(dirn) // 'saltout.dat', status='old',position='append')
    else
       call err_open(saltout_fp, file=trim(dirn) // 'saltout.dat', status='replace')
    end if
  end subroutine open_output_files
  subroutine close_output_files()
    call err_close(saltout_fp)
  end subroutine close_output_files
end module writing
